Page MenuHomePhabricator

Unstructured filters replaced by Structured filters may still affect the results
Closed, ResolvedPublic

Description

When viewing the new UI (structured filters), data may seem incomplete because legacy/invisible filters may still modify the query.

Steps:

  1. Make sure you are logged in and RC Filters beta is disabled
  2. In Preferences/RC, check "Show only edits that may have problems (and hide probably good edits)"
  3. Enable the RC Filters beta
  4. In Preferences/RC, notice that "Show only edits that may have problems (and hide probably good edits)" is not available anymore since it doesn't apply to the new UI (requires reload)
  5. On Special:RC, probably good edits are hidden

Note: there's isReplacedInStructuredUI in the filters definition but it doesn't seem to be used anywhere. Maybe the idea behind this field was to prevent this problem...

Event Timeline

SBisson created this task.Apr 4 2017, 3:21 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptApr 4 2017, 3:21 PM
Catrope added a subscriber: Catrope.Apr 4 2017, 5:15 PM

The field is used to export a data attribute that causes the client-side JS to hide the filter. You're right that we may need to use it to ignore the filter.

Mattflaschen-WMF added a comment.EditedApr 4 2017, 5:18 PM

I think the solution here is to set all the defaults to not-hide for legacy filters, if the Beta Feature is enabled. That way, they still display on the page and the URL still works (both helpful for no-JS and backwards-compatibility), but if it's not in the URL, it will never hide based on a default.

This can be done by core itself based on a getter for isReplacedInStructuredUi.

I think that's a good approach, because we do need the params to still work (for no-JS).

Change 346548 had a related patch set uploaded (by Sbisson):
[mediawiki/core@master] RC Filters: Disable defaults for legacy filters in structured UI

https://gerrit.wikimedia.org/r/346548

Change 346548 merged by jenkins-bot:
[mediawiki/core@master] RC Filters: Disable defaults for legacy filters in structured UI

https://gerrit.wikimedia.org/r/346548

Checked the fix in cawiki betalabs (enwiki betalabs does not have the option 'Show only edits that may have problems (and hide probably good edits)' in Preferences-Recent Cchanges):

Note (minor): From users' point of view it might look as an interruption of established workflow - if I had the option 'Show only edits that may have problems (and hide probably good edits)' checked, I would reasonably expect this setting to be transferred along with my other RC settings to my selection of filters when I enable 'New filters for edit review'.

QA Recommendation: Product should weigh in

jmatazzoni closed this task as Resolved.Apr 18 2017, 12:43 AM
jmatazzoni added a subscriber: jmatazzoni.

Thanks for the note @Etonkovidova. It's a good point. This change is specified in T159763. Yes, looking back, we could have kept this preference and worked it so that it simply selected the "May have problems" filter as a user default. I don't remember why we got rid of it. But at this point, I think we are moving forward to a model where users specify RC Page defaults on the RC Page. That will be superior. So let's move forward with this but look out for users who mention the issue.

Change 376794 had a related patch set uploaded (by Mattflaschen; owner: Mattflaschen):
[mediawiki/core@master] WIP: RCFilters: Keep the default for replaced filters, but allow override

https://gerrit.wikimedia.org/r/376794

SBisson removed SBisson as the assignee of this task.Sep 11 2017, 12:18 PM

Change 376794 abandoned by Mattflaschen:
WIP: RCFilters: Keep the default for replaced filters, but allow override

Reason:
This will be done by transforming the parameters, so the old parameters won't apply directly like this.

https://gerrit.wikimedia.org/r/376794